/* Copyright(C) 2006 Fujitsu Limited */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <errno.h>
#include <sys/shm.h>
#include <sys/mman.h>
#include <sys/sem.h>

#define KEY 12245933
#define SIZE 0x1000

int
main()
{
        int     ret;
        int     shmid;
        void   *addr;
	int i;
        int     semid;

	for (i = 0; i < 10000000; i++) {

		semid = semget(IPC_PRIVATE, 1, IPC_CREAT | 0777);
		if (semid < 0) {
			perror("semget failed ");
			goto out;
		}

	        shmid = shmget(KEY, SIZE ,IPC_CREAT | 0777);
        	if( shmid < 0 ) {
			perror("shmget failed ");
			goto out;
        	}

        	ret = shmctl(shmid, IPC_RMID, NULL);
        	if(ret < 0 ){
			perror("shmctl(IPC_RMID) failed ");
			goto out;
        	}

		ret = semctl(semid, 0 ,IPC_RMID);
        	if(ret < 0 ){
			perror("semctl(IPC_RMID) failed ");
			goto out;
        	}
	}

        exit(0);

out:
	printf("errno = %d\n",errno);
	exit(-1);

}
